Perl Programming Documentation
Download Perl
Explore

Manual

- Overview
- Tutorials
- FAQs
- History / Changes
- License

Reference

- Language
- Functions
- Operators
- Special Variables
- Pragmas
- Utilities
- Internals
- Platform Specific

Modules

- A • B • C • D • E
- F • G • H • I • L
- M • N • O • P • S
- T • U • X

Tools

- Preferences

# values

Perl 5 version 16.0 documentation
Go to top
Show recent pages
Recently read

# values

Perl functions A-Z | Perl functions by category | The 'perlfunc' manpage

- values HASH

- values ARRAY
- values EXPR

  In list context, returns a list consisting of all the values of the named hash. In Perl 5.12 or later only, will also return a list of the values of an array; prior to that release, attempting to use an array argument will produce a syntax error. In scalar context, returns the number of values.

  When called on a hash, the values are returned in an apparently random order. The actual random order is subject to change in future versions of Perl, but it is guaranteed to be the same order as either the `keys` or `each` function would produce on the same (unmodified) hash. Since Perl 5.8.1 the ordering is different even between different runs of Perl for security reasons (see Algorithmic Complexity Attacks in perlsec).

  As a side effect, calling values() resets the HASH or ARRAY's internal iterator, see each. (In particular, calling values() in void context resets the iterator with no other overhead. Apart from resetting the iterator, `values @array` in list context is the same as plain `@array` . (We recommend that you use void context `keys @array` for this, but reasoned that taking `values @array` out would require more documentation than leaving it in.)

  Note that the values are not copied, which means modifying them will modify the contents of the hash:

          for (values %hash)      { s/foo/bar/g }   # modifies %hash values    for (@hash{keys %hash}) { s/foo/bar/g }   # same

  Starting with Perl 5.14, `values` can take a scalar EXPR, which must hold a reference to an unblessed hash or array. The argument will be dereferenced automatically. This aspect of `values` is considered highly experimental. The exact behaviour may change in a future version of Perl.

          for (values $hashref) { ... }    for (values $obj->get_arrayref) { ... }

  To avoid confusing would-be users of your code who are running earlier versions of Perl with mysterious syntax errors, put this sort of thing at the top of your file to signal that your code will work only on Perls of a recent vintage:

          use 5.012;	# so keys/values/each work on arrays    use 5.014;	# so keys/values/each work on scalars (experimental)

  See also `keys`, `each`, and `sort`.